Subject: hung tasks on shutdown in linux-next-202409{20,23,24,25}

From: Bert Karwatzki <[email-masked]>
Date: Wed, 25 Sep 2024 13:40:01 +0200

Since linux-next-20240920 my Msi Alpha 15 Laptop has repeatedly suffered
from hung tasks when shutting down (though not on every shutdown). After
some time when shutting down does not work the following messages about
hung tasks appear on screen:
INFO: task systemd-shutdow:1 blocked for more than 61 seconds.
and several of these
INFO: task kworker/u64:*:* blocked for more than 61 seconds.

The error can be provoked by repeatedly rebooting the system, and so
I bisected the error between v6.11 and next-20240920. As the first bad
commit I got the merge commit

commit 32035d78548754935544d2ae23d39c6090ad0b50
Merge: 9dfe3a6f3f77 6a36d828bdef
Author: Stephen Rothwell <[email-masked]>
Date:   Fri Sep 20 12:48:01 2024 +1000

    Merge branch 'driver-core-next' of git://git.kernel.org/pub/scm/linux/kernel/git/gregkh/driver-core.git

Both parents of the commit tested as not affected by the bug. (I declared a commit as
good when it survived ten reboot cycles without a hang, the bad commits usually
hung after at most 3 reboots).

The error is also still present in next-202409{23,24,25}. In next-20240925 I can
fix the issue by the following reverting commit 1a0f3e00961c (commit 1a0f3e00961c
is similar to commit 32035d785487, both merge branch 'driver-core-next'
from gregkh/driver-core.git):

commit 8a16b660bc611a327d5aa227a9dde160e6703faf (HEAD -> driver_core_shutdown_hang)
Author: Bert Karwatzki <[email-masked]>
Date:   Wed Sep 25 13:15:55 2024 +0200

    Revert "Merge branch 'driver-core-next' of git://git.kernel.org/pub/scm/linux/kernel/git/gregkh/driver-core.git"

    This can fixes the hung tasks on shutdown.

    This reverts commit 1a0f3e00961c51edab2d8060b06b1f227a7250ca, reversing
    changes made to d0ba665d37dda73e2ee8339dfad24bb9cc8521f6.

Bert Karwatzki